#!/usr/bin/env octave

N=2000; A=5; fx=100; fp=1000;
dt=1/fp;
t=dt*(0:N-1);
sn = A * sin(2*pi*fx*t); %sygnal nosny
sm = 0.2 * A * sin(2*pi*(fx / 20 + rand(1)*fx/10) * t); % cz. modulujaca

sa = sn .+ sn .* sm;

clf;
subplot(311); plot(t,sn); grid; title('Sygna nony sn(t)'); xlabel('czas [s]');
subplot(312); plot(t,sm); grid; title('Sygna modulujcy sm(t)'); xlabel('czas [s]');
subplot(313); plot(t,sa); grid; title('Sygna zmodulowany sa(t)'); xlabel('czas [s]');

pause;


X = fft(sa);   %szybka, dyskretna transformacja Fouriera
df = 1/(N*dt); %czstotliwo podstawowa f0=df=1/T=1/(N*dt)
f= df*(0:N-1);   %kolejne czstotliwoci w szeregu Fouriera
subplot(221); plot(f,real(X)); grid; title('Real(X)'); xlabel('Hz');
subplot(222); plot(f,imag(X)); grid; title('Imag(X)'); xlabel('Hz');
subplot(223); plot(f,abs(X)); grid; title('Abs(X)'); xlabel('Hz');
subplot(224); plot(f(1:N/8+1),abs(X(1:N/8+1))/(N/2)); grid; title('Po wyskalowaniu - i ograniczona czestosc'); pause
